package urgrip.programnodes;

import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.program.ContributionConfiguration;
import com.ur.urcap.api.contribution.program.CreationContext;
import com.ur.urcap.api.contribution.program.ProgramAPIProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeService;
import com.ur.urcap.api.domain.data.DataModel;

import java.util.Locale;

public class GripperBlowoutNodeService implements SwingProgramNodeService<GripperBlowoutNodeContribution, GripperBlowoutNodeView> {

    @Override
    public String getId() {
        return "GripperBlowout";
    }

    @Override
    public void configureContribution(ContributionConfiguration configuration) {
        configuration.setChildrenAllowed(false);
    }

    @Override
    public String getTitle(Locale locale) {
        return "Grip: Blowout";
    }

    @Override
    public GripperBlowoutNodeView createView(ViewAPIProvider apiProvider) {
        return new GripperBlowoutNodeView(new V5Style());
    }

    @Override
    public GripperBlowoutNodeContribution createNode(
            ProgramAPIProvider apiProvider,
            GripperBlowoutNodeView view,
            DataModel model,
            CreationContext context) {
        return new GripperBlowoutNodeContribution(apiProvider, view, model);
    }

    public GripperBlowoutNodeService() {

    }
}
